Index: protocols/yahoo/yahoo_util.h
===================================================================
--- protocols/yahoo/yahoo_util.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo_util.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -61,15 +61,17 @@
 # define y_renew(type, mem, n)	(type *)realloc(mem, n)
 
-void * y_memdup(const void * addr, int n);
-char ** y_strsplit(char * str, char * sep, int nelem);
-void y_strfreev(char ** vector);
+void *y_memdup(const void *addr, int n);
+char **y_strsplit(char *str, char *sep, int nelem);
+void y_strfreev(char **vector);
 
-int strncasecmp(const char * s1, const char * s2, size_t n);
-int strcasecmp(const char * s1, const char * s2);
+#ifndef _WIN32
+int strncasecmp(const char *s1, const char *s2, size_t n);
+int strcasecmp(const char *s1, const char *s2);
 
-char * strdup(const char *s);
+char *strdup(const char *s);
 
 int snprintf(char *str, size_t size, const char *format, ...);
 int vsnprintf(char *str, size_t size, const char *format, va_list ap);
+#endif
 
 #endif
@@ -95,7 +97,7 @@
  * You must free it yourself
  */
-char * y_string_append(char * str, char * append);
-char * y_str_to_utf8(const char * in);
-char * y_utf8_to_str(const char * in);
+char *y_string_append(char *str, char *append);
+char *y_str_to_utf8(const char *in);
+char *y_utf8_to_str(const char *in);
 
 #endif
Index: query.c
===================================================================
--- query.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ query.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -31,5 +31,6 @@
 
 query_t *query_add( irc_t *irc, struct im_connection *ic, char *question,
-                    query_callback yes, query_callback no, void *data )
+                    query_callback yes, query_callback no, query_callback free,
+                    void *data )
 {
 	query_t *q = g_new0( query_t, 1 );
@@ -39,4 +40,5 @@
 	q->yes = yes;
 	q->no = no;
+	q->free = free;
 	q->data = data;
 	
@@ -64,5 +66,5 @@
 	}
 	
-	if( g_strcasecmp( set_getstr( &irc->set, "query_order" ), "lifo" ) == 0 || irc->queries == q )
+	if( g_strcasecmp( set_getstr( &irc->b->set, "query_order" ), "lifo" ) == 0 || irc->queries == q )
 		query_display( irc, q );
 	
@@ -94,5 +96,6 @@
 	
 	g_free( q->question );
-	if( q->data ) g_free( q->data ); /* Memory leak... */
+	if( q->free && q->data )
+		q->free( q->data );
 	g_free( q );
 }
@@ -179,5 +182,5 @@
 	query_t *q;
 	
-	if( g_strcasecmp( set_getstr( &irc->set, "query_order" ), "fifo" ) == 0 )
+	if( g_strcasecmp( set_getstr( &irc->b->set, "query_order" ), "fifo" ) == 0 )
 		q = irc->queries;
 	else
Index: query.h
===================================================================
--- query.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ query.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -33,5 +33,5 @@
 	struct im_connection *ic;
 	char *question;
-	query_callback yes, no;
+	query_callback yes, no, free;
 	void *data;
 	struct query *next;
@@ -39,5 +39,6 @@
 
 query_t *query_add( irc_t *irc, struct im_connection *ic, char *question,
-                    query_callback yes, query_callback no, void *data );
+                    query_callback yes, query_callback no, query_callback free,
+                    void *data );
 void query_del( irc_t *irc, query_t *q );
 void query_del_by_conn( irc_t *irc, struct im_connection *ic );
